/*
Kinectp낢
ڑ͑z肵ĂȂ
*/

#pragma once

#include <Windows.h>
#include <NuiApi.h>
#pragma comment(lib,"Kinect10.lib")

#include <opencv2/opencv.hpp>

class KinectSensor {
private:
	INuiSensor *kinect;				//LlNg̃nh(gƂ͂ύX)
	HANDLE streamEvent;				//Cxgp
	HANDLE imageStreamHandle;
	HANDLE depthStreamHandle;
	HANDLE skeletonStreamHandle;
	HANDLE streamHandles[3];
	INuiColorCameraSettings *kinectSettings;
	bool asyncDevice;
	int updateFlag[2];
	//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
	bool disableRGB, disableDepth;
	NUI_IMAGE_RESOLUTION cameraResolution, depthResolution;

	//fɑ΂[xlȂ̂ŒӁIIIIIIII
	std::vector<int> depth;			//p
	std::vector<int> depthPlayer;	//p
	cv::Mat frame;					//擾摜
	cv::Mat playerMask;				//}XN摜
	cv::Mat mapx, mapy;				//cݕ␳p
	//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
	std::vector<unsigned char> colorCameraFrameBuffer;
	std::vector<unsigned char> depthCameraFrameBuffer;

public:
	KinectSensor(NUI_IMAGE_RESOLUTION cameraResolution, NUI_IMAGE_RESOLUTION depthResolution, int kinectID);
	~KinectSensor();
	void start();
	void stop();
	void setCameraSwitch(bool rgb, bool depth);
	//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-

	int count;			//kinect̐
	//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
	int updateSensor(); //ΌĂ΂悤ɂ
	void remapFrame(); //cݕ␳
	//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
	cv::Mat& getFrame(){
		return frame;
	}
	INuiSensor* getKinect(){
		return kinect;
	}
	bool getDeviceUpdateSuccessful(int id){
		return this->updateFlag[id];
	}
	std::vector<unsigned char>& getColorCameraFrameBuffer(){
		return colorCameraFrameBuffer;
	}
	std::vector<unsigned char>& getDepthCameraFrameBuffer(){
		return depthCameraFrameBuffer;
	}

	cv::Point3d getLocalPosition(cv::Point p){
		return getLocalPosition(p.x, p.y);
	}
	cv::Point3d getLocalPosition(int x, int y){
		Vector4 r = ::NuiTransformDepthImageToSkeleton(x, y, this->depth[y*width + x] << 3, depthResolution);
		cv::Point3d ret;
		ret.x = r.x * 1000.0;
		ret.y = r.y * 1000.0;
		ret.z = r.z * 1000.0;

		return ret;
	}
	cv::Point2f getLocalToUVPosition(cv::Mat localPosition){
		if(localPosition.rows == 3) return getLocalToUVPosition(cv::Point3d(localPosition.at<double>(0, 0), localPosition.at<double>(1, 0), localPosition.at<double>(2, 0)));
		else return getLocalToUVPosition(cv::Point3d(localPosition.at<double>(0, 0), localPosition.at<double>(0, 1), localPosition.at<double>(0, 2)));
	}
	cv::Point2f getLocalToUVPosition(cv::Point3d localPosition){
		Vector4 skeleton;
		skeleton.x = localPosition.x / 1000.0;
		skeleton.y = localPosition.y / 1000.0;
		skeleton.z = localPosition.z / 1000.0;

		cv::Point2f ret;
		//WCg]s̐̕ɐL΂̈ʒu𓾂
		::NuiTransformSkeletonToDepthImage(skeleton, &ret.x, &ret.y, cameraResolution);

		return ret;
	}

	//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
	DWORD width, height;			//𑜓x
	DWORD depthWidth, depthHeight;	//Depth̉𑜓x
};