#include "KinectSensor.h"

/*
Kinectt[f[^𓾂
Ԃl: 0=, -1=s
*/
int KinectSensor::updateSensor(){
	int r_result = 0;

	if(!asyncDevice) {
		//f[^̍XV҂
		DWORD ret = ::WaitForSingleObject(streamEvent, 0); //҂ȂꍇINFINITE0ɂ

		//!!҂Ȃꍇ
		if(ret == WAIT_TIMEOUT) { //܂f[^ĂȂ
			return -1;
		}
		if(ret == WAIT_OBJECT_0) ::ResetEvent(streamEvent);
	}
	else {
		r_result = -1; //񓯊̏ꍇ͂Ƃ肠sZbg
	}

	HRESULT result;

	//==================================================================================
	//RGBJ̃t[f[^擾
	NUI_IMAGE_FRAME imageFrame = {0};
	if(disableRGB == false) {
		result = kinect->NuiImageStreamGetNextFrame(imageStreamHandle, 0, &imageFrame);
		if(result == S_OK) {
			r_result = 0;
			updateFlag[0] = true;
			//摜擾
			NUI_LOCKED_RECT colorData;
			imageFrame.pFrameTexture->LockRect(0, &colorData, 0, 0);

			//摜Rs[(Kinect擾f[^OpenCVŎg`֕ϊ)
			/*
			ӁFKinect瓾J[摜RGBl8bit*4CV8UC4,
			Depth16bitf[^Ȃ̂łς˂΂Ȃ
			*/
			//frame = cv::Mat(height, width, CV_8UC4, colorData.pBits).clone();					//ALPHA̒lꍇ
			//_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
			// ALPHA̒l͕KvȂׁAŐ؂藎Ƃ
			//_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/_/
			if(!disableRGB) {
				frame = cv::Mat(height, width, CV_8UC3);	//3`l(BGR)ō쐬
				cv::cvtColor(cv::Mat(height, width, CV_8UC4, colorData.pBits).clone(), frame, CV_BGRA2BGR);		//4`l->3`lɕϊRs[
			
				std::copy(colorData.pBits, colorData.pBits + colorData.size, colorCameraFrameBuffer.begin());
			}

			//t[f[^̊J
			try {
				kinect->NuiImageStreamReleaseFrame(imageStreamHandle, &imageFrame);
			} catch(const char* str) {
				throw std::runtime_error(str);
			}
		}
		else {
			//std::cout << "RGBJ܂" << std::endl;
			updateFlag[0] = false;
		}
	}

	//==================================================================================

	//J̃t[擾
	NUI_IMAGE_FRAME depthFrame = {0};
	result = kinect->NuiImageStreamGetNextFrame(depthStreamHandle, 0, &depthFrame);
	if(result == S_OK) {
		r_result = 0;
		updateFlag[1] = true;
		//J̃f[^擾
		NUI_LOCKED_RECT depthData = {0};
		depthFrame.pFrameTexture->LockRect(0, &depthData, 0, 0);

		//std::copy(depthData.pBits, depthData.pBits + depthData.size, depthCameraFrameBuffer.begin());

		////̕ӏd
		//{
		//	USHORT* depth = (USHORT*)depthData.pBits;
		//	int c = depthData.size / sizeof(USHORT);
		//	int target;
		//	long size = this->depth.size();
		//	for(int i=0;i<c;i++){
		//		LONG uvx, uvy;

		//		kinect->NuiImageGetColorPixelCoordinatesFromDepthPixelAtResolution(
		//			cameraResolution, depthResolution, NULL,
		//			i%width, i/width, 0, &uvx, &uvy);

		//		target = uvy*width + uvx;	//ANZXf肷
		//		if(target > 0 && target < size){
		//			this->depth[target] = ::NuiDepthPixelToDepth(depth[i]);
		//			this->depthPlayer[target] = ::NuiDepthPixelToPlayerIndex(depth[i]);
		//		}
		//	}
		//}

		//t[f[^̊J
		try {
			kinect->NuiImageStreamReleaseFrame(depthStreamHandle, &depthFrame);
		} catch(const char* str) {
			throw std::runtime_error(str);
		}

	}
	else {
		//std::cout << "J܂" << std::endl;
		updateFlag[1] = false;
	}
	//==================================================================================

	return r_result;
}

/*
cݕ␳
mapxmapyۂǂ悤EEE
*/
void KinectSensor::remapFrame(){
	cv::remap(frame, frame, mapx, mapy, CV_INTER_LINEAR); //cݕ␳
}